# @procore/data-table-saved-views

> [!WARNING]
> It's an initial version of this package (0.0.0) intended to demo the Saved Views capabilities. The design and API integration aren't finished yet, so please don't use it on production.
> The final design and API integration are going to be delivered with next version (0.0.1) soon.

Saved Views Component for integration with @procore/data-table

## Installation

### In a web application, micro frontend or hydra client

```shell script
yarn add @procore/data-table-saved-views
```

**NOTE:** Ensure that the following peer dependencies for `@procore/data-table-saved-views` are also installed:

- `@procore/core-react`: `^12`
- `react`: `>=16.8`
- `styled-components`: `^5.3.0`

### In a npm package or library

```
yarn add -P @procore/data-table-saved-views^1.0.0 # adds the package as a peer dependency
yarn add -D @procore/data-table-saved-views # adds as a dev dependency, for tests, storybook, etc.
```

**NOTE:** Ensure that the following peer dependencies for `@procore/data-table-saved-views` are also installed _as peer dependencies_ and as dev dependencies (for tests, storybook, etc.):

- `@procore/core-react`: `^12`
- `react`: `>=16.8`
- `styled-components`: `^5.3.0`

## Usage

```js
import { useSavedViews } from '@procore/data-table-saved-views';
```

```jsx
const { SavedViews } = useSavedViews(
      onSelect,
      onEdit,
      onDelete,
      onCreate,
      onUpdate,
      AllItemsOptionFlag,
      savedViewsGroups: savedGroups,
      isAdmin: true,
      currentFilters,
      currentColumnState,
      onTableConfigChange,
      tableConfig,
      tableApi,
      currentRowHeight,
      stickyViewsKey: 'currentSavedView');

<SavedViews />
```

## Development

This project uses [`yarn`][yarn], and supports the following commands:

- `build`: builds and bundles the project.
- `format`: runs [`prettier`][prettier] on the project.
- `format:check`: validates that the source code conforms to the [`prettier`][prettier] configuration.
- `lint`: lints the source code.
- `storybook`: starts up the storybook development server on port 6006.
- `build-storybook`: generates a static version of the storybook.
- `test`: runs the unit test suite.
- `test:dev`: run the unit test suite in watch mode.

[prettier]: https://prettier.io/
[yarn]: https://classic.yarnpkg.com/
